%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Exemplo de Aplicao da Tcnica do Discriminante Linear de Fisher%%%
%%%                   Adrielle C. Santana                           %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y=Fisher2D(x1,x2)
%Entrada de dados: tem-se duas raas de animais, A e B, com caractersticas x1 e x2

x1A=[6.36; 5.92; 5.92; 6.44; 6.4; 6.56; 6.64; 6.68; 6.72; 6.76; 6.72];
x2A=[5.24; 5.12; 5.36; 5.64; 5.16; 5.56; 5.36; 4.96; 5.48; 5.6; 5.08];
x1B=[6; 5.6; 5.64; 5.76; 5.96; 5.72; 5.64; 5.44; 5.04; 4.56; 5.48; 5.76];
x2B=[4.88; 4.64; 4.96; 4.8; 5.08; 5.04; 4.96; 4.88; 4.44; 4.04; 4.2; 4.8];

%Plotando valores de entrada de treinamento
subplot(1,2,1)
plot(x1A,x2A,'or')
hold on
plot(x1B, x2B, '*')
hold off
grid on
xlabel('x1')
ylabel('x2')
title('Dados de Treinamento')

%Encontrando as mdias e matrizes de covarincia de para cada raa

mA=[mean(x1A);mean(x2A)];
mB=[mean(x1B);mean(x2B)];

covA=cov(x1A,x2A);
covB=cov(x1B,x2B);

%Calculando a matriz de covarincia amostral
nA=length(x1A); %quantidade de amostras da raa A
nB=length(x1B); %quantidade de amostras da raa B

Sc=(((nA-1)/((nA-1)+(nB-1)))*covA)+(((nA-1)/((nB-1)+(nB-1)))*covB);
invSc=inv(Sc);

%Obteno do estimador linear amostral de Fisher

subM=mA-mB;

Est=(subM')*(invSc);

%Determinao do ponto mdio das populaes

MA=Est*mA; %Projeo da mdia de A
MB=Est*mB; %Projeo da mdia de B

M=(MA+MB)/2;

%Projeo de novas entradas
D=Est*[x1;x2];

if (MA>MB)
    if(D>=M)
        subplot(1,2,2)
        plot(x1A,x2A,'or')
        hold on
        plot(x1,x2,'ok')
        hold on
        plot(x1B, x2B, '*')
        hold off
        grid on
        xlabel('x1')
        ylabel('x2')
        title('Classificao de Nova Amostra')
    else
        subplot(1,2,2)
        plot(x1A,x2A,'or')
        hold on
        plot(x1,x2,'*k')
        hold on
        plot(x1B, x2B, '*')
        hold off
        grid on
        xlabel('x1')
        ylabel('x2')
        title('Classificao de Nova Amostra')
    end
else
    if(D>=M)
        subplot(1,2,2)
        plot(x1A,x2A,'or')
        hold on
        plot(x1,x2,'*k')
        hold on
        plot(x1B, x2B, '*')
        hold off
        grid on
        xlabel('x1')
        ylabel('x2')
        title('Classificao de Nova Amostra')
    else
        subplot(1,2,2)
        plot(x1A,x2A,'or')
        hold on
        plot(x1,x2,'ok')
        hold on
        plot(x1B, x2B, '*')
        hold off
        grid on
        xlabel('x1')
        ylabel('x2')
        title('Classificao de Nova Amostra')
    end
end
end


